<?php
	
	global $wp_session;
	if(!isset($wp_session['psfb_errors'])){
		$psfb_errors = array();
	} else {
		$psfb_errors = $wp_session['psfb_errors'];
	}
	if(!isset($wp_session['psfb_values'])){
		$psfb_values = array();
	} else {
		$psfb_values = $wp_session['psfb_values'];
	}
	if(!isset($wp_session['psfb_success'])){
		$psfb_success = array();
	} else {
		$psfb_success = $wp_session['psfb_success'];
	}
	
	require_once(dirname(__FILE__).'/vars.inc.php');

if(!isset($submitted_j)){
	$psform = get_post( $_POST['psfb_form_id'] );
		
	$j = json_decode($psform->post_content);
} else {
	$j = $submitted_j;
}
if(!function_exists('validate_url')){
	function validate_url($url){
		if (!preg_match("/\b(?:(?:https?|ftp):\/\/|www\.)[-a-z0-9+&@#\/%?=~_|!:,.;]*[-a-z0-9+&@#\/%=~_|]/i",$url)) {
	  	return false;
		}
		return true;
	}
}

/**** ANTI SPAM ****/

if(!isset($submitted_j)){
	//honeypot
	if(isset($_POST['psfb_hon_as']) && !empty($_POST['psfb_hon_as'])){
		if($_POST['psfb_hon_as']!=''){
			//honeypot is not empty - must be spam
			$psfb_errors[$_POST['psfb_form_id']] = array('psfb_message' => __('Honeypot is not empty','psfbldr') );
			$wp_session['psfb_errors'] = $psfb_errors;
			wp_session_commit();
			wp_safe_redirect( $_POST['psfb_pageurl'].'#planso_forms_'.$_POST['psfb_form_id'].'_'.$_POST['psfb_form_cnt'] );
		}
	}
	
	if(isset($wp_session['psfb_anti_spam'][$_POST['psfb_form_id']][$_POST['psfb_cnt_check']])){
		//psfb_hon_as2
		if( $wp_session['psfb_anti_spam'][$_POST['psfb_form_id']][$_POST['psfb_cnt_check']] == $_POST['psfb_hon_as2'] ){
			//session and value are equal - seems to be a user
		} else {
			//either no session available or 
			if(strlen($_POST['psfb_hon_as2']) != 32){
				//md5 was changed is definitly not 32 chars and therefore spam
				$psfb_errors[$_POST['psfb_form_id']] = array('psfb_message' => __('Salt missmatch','psfbldr') );
				$wp_session['psfb_errors'] = $psfb_errors;
				wp_session_commit();
				wp_safe_redirect( $_POST['psfb_pageurl'].'#planso_forms_'.$_POST['psfb_form_id'].'_'.$_POST['psfb_form_cnt'] );
			}
		}
	}
	if(isset($j->javascript_antispam) && $j->javascript_antispam==true){
		if( !isset($_POST['psfb_js_as']) || empty($_POST['psfb_js_as'])){
			//javascript antispam field not submitted - spam
			$psfb_errors[$_POST['psfb_form_id']] = array('psfb_message' => __('Anti spam field was omitted','psfbldr') );
			$wp_session['psfb_errors'] = $psfb_errors;
			wp_session_commit();
			wp_safe_redirect( $_POST['psfb_pageurl'].'#planso_forms_'.$_POST['psfb_form_id'].'_'.$_POST['psfb_form_cnt'] );
		} else {
			if($_POST['psfb_js_as']!=$_POST['psfb_hon_as2']){
				//fields dont match - spam
				$psfb_errors[$_POST['psfb_form_id']] = array('psfb_message' => __('Anti spam fields dont match','psfbldr') );
				$wp_session['psfb_errors'] = $psfb_errors;
				wp_session_commit();
				wp_safe_redirect( $_POST['psfb_pageurl'].'#planso_forms_'.$_POST['psfb_form_id'].'_'.$_POST['psfb_form_cnt'] );
			}
		}
	}
}//ende !isset($submitted_j)

/****** VALIDATION *********/
//if errors register values in session and redirect
$errors = array();
$mail_replace = array();
$file_keys = array();
$cnt = 1;
/*echo print_r($j->fields);
exit();*/
if(isset($j->fields) && count($j->fields)>0){
	foreach($j->fields as $row){
		foreach($row as $col){
			$cnt ++;
			$mytype = $col->type;
			if(isset($fieldtypes[$mytype])){
				$fieldinfo = $fieldtypes[$mytype];
			} else {
				//loop through fieldtypes and return best match
				foreach($fieldtypes as $fts){
					if($fts['type']==$mytype){
						$fieldinfo = $fts;
					}
				}
			}
			$fieldtype = $fieldinfo['type'];
			$post_indexes = array();
			$post_types = array();
			if(isset($col->field_options) && isset($col->field_options->names)){
				$fcnt = 0;
				foreach($col->field_options->names as $name){
					$name = preg_replace("/[^A-Za-z0-9_]+/", '_', $name);
					if(trim($name)==''){
						$name = 'field'.$cnt.'_'.$fcnt;
					}
					$post_indexes[] = $name;
					$post_types[] = $col->type;
					$fcnt ++;
				}
				
			} else {
				
			}
			
			if(!isset($col->name) || empty($col->name)){
				if(isset($col->label) && !empty($col->label)){
					$col->name = $col->label;
				} else {
					$col->name = 'autogenerated'.time().rand(10,3);
					$col->label = $col->name;
				}
			}
			if(count($post_indexes)<1){
				$col->name = preg_replace("/[^A-Za-z0-9_]+/", '_', $col->name);
				
				if(trim($col->name)==''){
					$col->name = 'field'.$cnt;
				}
				$post_indexes[] = $col->name;
				$post_types[] = $col->type;
			} 
			
      
			foreach($post_indexes as $i => $pidx){
				
				$post_value = '';
				if(isset($_POST[$pidx])){
					$post_value = $_POST[$pidx];
					if(is_array($post_value)){
						if(count($post_value)>0){
							$tmp = implode(', ',$post_value);
							$post_value = $tmp;
						} else {
							$post_value = '';
						}
					}
					$post_value = trim($post_value);
				  $post_value = stripslashes($post_value);
				  $post_value = htmlspecialchars($post_value);
				}
				
				if( isset($col->required) && $post_value!='c34774bc9ee05f717f36af1bd98ac0939120ccc5592cf7863d0050afc2652ed5' && ($col->required==true || $col->required=='required' || $col->required=='true')){
					
					if(strstr($post_types[$i],'file')){
						//file && required
						if(is_array($_FILES[$pidx]['tmp_name'])){
							foreach($_FILES[$pidx]['tmp_name'] as $key=>$val){
								if($_FILES[$pidx]['error'][$key]!=UPLOAD_ERR_OK){
									$errors[$pidx]['error'] = true;
									$form_file_upload_error_message = __('File upload error','psfbldr');
									if(!empty($j->form_file_upload_error_message)){
										$form_file_upload_error_message=$j->form_file_upload_error_message;
									}
									$errors[$pidx]['message'] = $form_file_upload_error_message;
								}
							}
						} else {
							if($_FILES[$pidx]['error']!=UPLOAD_ERR_OK){
								$errors[$pidx]['error'] = true;
								$form_file_upload_error_message = __('File upload error','psfbldr');
								if(!empty($j->form_file_upload_error_message)){
									$form_file_upload_error_message=$j->form_file_upload_error_message;
								}
								$errors[$pidx]['message'] = $form_file_upload_error_message;
							}
						}
						
					} else if(strstr($post_types[$i],'checkbox')){
						if($post_value==''){
							//fehler - feld muss ausgefllt sein
							$errors[$pidx]['error'] = true;
							$errors[$pidx]['required'] = true;
							
							$form_field_required_warning_message =__('This field is required','psfbldr');
							
							if(!empty($j->form_field_required_warning_message)){
								$form_field_required_warning_message=$j->form_field_required_warning_message;
							}
							
							$errors[$pidx]['message'] = $form_field_required_warning_message;
						}
						
					} else {
						//all other fields
						if(!isset($post_value) || empty($post_value)){
							//fehler - feld muss ausgefllt sein
							$errors[$pidx]['error'] = true;
							$errors[$pidx]['required'] = true;
							
							$form_field_required_warning_message =__('This field is required','psfbldr');
							
							if(!empty($j->form_field_required_warning_message)){
								$form_field_required_warning_message=$j->form_field_required_warning_message;
							}
							
							$errors[$pidx]['message'] = $form_field_required_warning_message;
						}
						
						if($post_types[$i]=='email' && !is_email($post_value)){
							$errors[$pidx]['error'] = true;
							
							$form_field_invalid_email_message = __('Invalid E-Mail','psfbldr');
							
							if(!empty($j->form_field_invalid_email_message)){
								$form_field_invalid_email_message=$j->form_field_invalid_email_message;
							}
							
							$errors[$pidx]['message'] = $form_field_invalid_email_message;
						}
						
						if($post_types[$i]=='url' && !validate_url($post_value)){
							$errors[$pidx]['error'] = true;
							
							$form_field_invalid_url_message = __('Invalid URL','psfbldr');
							
							if(!empty($j->form_field_invalid_url_message)){
								$form_field_invalid_url_message=$j->form_field_invalid_url_message;
							}
							
							$errors[$pidx]['message'] = $form_field_invalid_url_message;
						}
					}
				}//end required
				if($post_value == 'c34774bc9ee05f717f36af1bd98ac0939120ccc5592cf7863d0050afc2652ed5'){
					$post_value = '';
				}
				$mail_replace[$pidx] = $post_value;
				if(strstr($post_types[$i],'file')){
					$file_keys[] = $pidx;
				} else {
					$zmail_replace[$pidx] = $post_value;
				}
				
			}//end post_indexes each
			
		}
	}
}

if(count($errors)<1){
	
	$page_detail_atts = array(
		'id' => $psform->ID,
		'permalink' => $_POST['psfb_pageurl'],
		'title' => $psform->post_title,
		'mail_replace' => $mail_replace,
		'zmail_replace' => $zmail_replace,
		'j' => $j
	);
	
	
	/*
	* Run custom validation filter, should return true if valid, or an error message string when invalid
	*/
	$psfb_custom_validation_passed = apply_filters( 'psfb_validate_form_request', true, $page_detail_atts );
	if( true !==  $psfb_custom_validation_passed){
		$psfb_errors[$_POST['psfb_form_id']] = array('psfb_message' => (string)$psfb_custom_validation_passed);
		$wp_session['psfb_errors'] = $psfb_errors;
		wp_session_commit();
		wp_safe_redirect( $_POST['psfb_pageurl'].'#planso_forms_'.$_POST['psfb_form_id'].'_'.$_POST['psfb_form_cnt'] );
		exit;
	}
	
	$attachments = array();
	$mail_replace_encoded_attachments= array();
	$zattachments = array();
	$has_attachments = false;
	if(count($file_keys)>0){
		$wp_upload_dir = wp_upload_dir();
		if(!is_dir($wp_upload_dir['basedir'].'/planso-forms/')){
			mkdir( $wp_upload_dir['basedir'].'/planso-forms/',0777 );
		}
		$upload_dir = $wp_upload_dir['basedir'].'/planso-forms/'.wp_session_id();
		$upload_url = $wp_upload_dir['baseurl'].'/planso-forms/'.wp_session_id();
		if(!is_dir($upload_dir)){
			mkdir( $upload_dir,0777 );
		}
		foreach($file_keys as $f){
			if(isset($_FILES[$f])){
				if(is_array($_FILES[$f]['tmp_name'])){
					foreach($_FILES[$f]['tmp_name'] as $key => $tmp_name){
						if($_FILES[$f]['error'][$key]==UPLOAD_ERR_OK){
							$has_attachments = true;
					    $file_name = $_FILES[$f]['name'][$key];
					    $file_size = $_FILES[$f]['size'][$key];
					    $file_tmp = $_FILES[$f]['tmp_name'][$key];
					    $file_type = $_FILES[$f]['type'][$key];  
					    
					    $wcnt = 1;
					    if(is_file($upload_dir.'/'.$file_name)){
					    	$fp = explode('.',$file_name);
					    	$ext = strtolower(array_pop($fp));
					    	$file_name_base = implode('.',$fp);
						    while(is_file($upload_dir.'/'.$file_name_base.'_'.$wcnt.'.'.$ext)){
						    	$wcnt++;
						    }
					    	$file_name = $file_name_base.'_'.$wcnt.'.'.$ext;
					  	}
					    
					    move_uploaded_file($file_tmp, $upload_dir.'/'.$file_name);
					    $attachments[] = $upload_dir.'/'.$file_name;
					    $zattachments[$f][] = $upload_dir.'/'.$file_name;
					    $zuattachments[$f][] = $upload_url.'/'.$file_name;
					  }
					}
				} else if($_FILES[$f]['error']==UPLOAD_ERR_OK){
					
					$has_attachments = true;
					$file_name = $_FILES[$f]['name'];
			    $file_size =$_FILES[$f]['size'];
			    $file_tmp =$_FILES[$f]['tmp_name'];
			    $file_type=$_FILES[$f]['type'];  
			    
			    
			    $wcnt = 1;
			    if(is_file($upload_dir.'/'.$file_name)){
			    	$fp = explode('.',$file_name);
			    	$ext = strtolower(array_pop($fp));
			    	$file_name_base = implode('.',$fp);
			    	
				    while(is_file($upload_dir.'/'.$file_name_base.'_'.$wcnt.'.'.$ext)){
				    	$wcnt++;
				    }
			    	$file_name = $file_name_base.'_'.$wcnt.'.'.$ext;
			  	}
					    
			    move_uploaded_file($file_tmp, $upload_dir.'/'.$file_name);
			    $attachments[] = $upload_dir.'/'.$file_name;
				  $zattachments[$f][] = $upload_dir.'/'.$file_name;
				  $zuattachments[$f][] = $upload_url.'/'.$file_name;
			    
				}
			}
		}
	}
	
	if(!$has_attachments && empty($attachments)){
		$wp_upload_dir = wp_upload_dir();
		if(!is_dir($wp_upload_dir['basedir'].'/planso-forms/')){
			mkdir( $wp_upload_dir['basedir'].'/planso-forms/',0777 );
		}
		$upload_dir = $wp_upload_dir['basedir'].'/planso-forms/'.wp_session_id();
		$upload_url = $wp_upload_dir['baseurl'].'/planso-forms/'.wp_session_id();
		if(!is_dir($upload_dir)){
			mkdir( $upload_dir,0777 );
		}
	}
	if(isset($_POST) && !empty($_POST) ){
		foreach($_POST as $k => $v){
			if(isset($v) && !is_array($v)){
				if(preg_match("/data:(([a-zA-Z0-9-.])+\/([a-zA-Z0-9-.])+);base64,/",$v,$res)){
					if($res && is_array($res) && count($res)>0){
						$file_extention='';
						foreach($psfb_mime_types as $ext => $mime){
							if($res[1]==$mime){
								$file_extention = $ext;
							}
						}
						$filestr = base64_decode(str_replace($res[0],'',$v));
						$file_name = md5($k.time().rand(1,999)).$file_extention;
						$has_attachments = true;
						file_put_contents($upload_dir.'/'.$file_name,$filestr);
						$mail_replace_encoded_attachments[$k] = $file_name;
				    $attachments[] = $upload_dir.'/'.$file_name;
					  $zattachments[$k][] = $upload_dir.'/'.$file_name;
					  $zuattachments[$k][] = $upload_url.'/'.$file_name;
					}
				}
			}	
		}
	}
	
	
	$page_detail_atts['attachments'] = $attachments;
	$page_detail_atts['zattachments'] = $zattachments;
	$page_detail_atts['has_attachments'] = $has_attachments;
	$page_detail_atts['mail_replace_encoded_attachments'] = $mail_replace_encoded_attachments;
	
	//print_r($page_detail_atts['mail_replace_encoded_attachments']);
	//exit();
	do_action( 'psfb_submit_after_error_check_success',$page_detail_atts );

	//send mails and notifications
	require_once( dirname(__FILE__).'/submit_notifications.php');
	
	
	
	
	do_action( 'psfb_submit_before_redirect_successfull',$page_detail_atts );
	
	if(isset($j->thankyou_page_url) && validate_url($j->thankyou_page_url)){
		
		if(!empty($mail_replace)){
			foreach($mail_replace as $k=>$v){
				$j->thankyou_page_url = str_replace('['.$k.']',$v,$j->thankyou_page_url);
			}
		}
		wp_redirect( $j->thankyou_page_url );
	} else {
		$psfb_success[$_POST['psfb_form_id']] = true;
		$wp_session['psfb_success'] = $psfb_success;
		wp_session_commit();
		wp_safe_redirect( $_POST['psfb_pageurl'].'#planso_forms_'.$_POST['psfb_form_id'].'_'.$_POST['psfb_form_cnt'] );
	}
	exit();
	
}//no errors
else {
	do_action( 'psfb_submit_before_redirect_error' );
	//error: register in session
	$psfb_errors[$_POST['psfb_form_id']] = $errors;
	$wp_session['psfb_errors'] = $psfb_errors;
	$psfb_values[$_POST['psfb_form_id']] = $_POST;
	$wp_session['psfb_values'] = $psfb_values;
	wp_session_commit();
	wp_safe_redirect( $_POST['psfb_pageurl'].'#planso_forms_'.$_POST['psfb_form_id'].'_'.$_POST['psfb_form_cnt'] );
	exit();
}

?>